﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.8
@EndOfDesignText@
'Author: Alexander Stolte
'Version: 1.02
#If Documentation
Versions:
V1.00
	-Release
V1.01
	-Add BaseResize Event
V1.02
	-Add SkipButtonClicked Event
	-Add SkipButtonMode
		-SkipButtonMode_SKIP
		-SkipButtonMode_CLOSE
V1.03
	-BugFix
V1.04
	-Add compatibility for AS_ViewPager Version 2.0
#End If

#DesignerProperty: Key: NextButton, DisplayName: Next Button Text, FieldType: String, DefaultValue: Next , Description: Text on Next Button
#DesignerProperty: Key: BackButton, DisplayName: Back Button Text, FieldType: String, DefaultValue: Back , Description: Text on Back Button
#DesignerProperty: Key: SkipButton, DisplayName: Skip Button Text, FieldType: String, DefaultValue: Skip , Description: Text on Skip Button
#DesignerProperty: Key: FinishButtonText, DisplayName: Finish Button Text, FieldType: String, DefaultValue: Get Started , Description: Text on Finish Button
#DesignerProperty: Key: ShowSkipButton, DisplayName: Show Skip Button, FieldType: Boolean, DefaultValue: True, Description: Enable Skip Button , Description: Enable Skip Button
#DesignerProperty: Key: ShowFinishButtonText, DisplayName: Show Finish Button Text, FieldType: Boolean, DefaultValue: True, Description: Enable Finish Button
#DesignerProperty: Key: ShowNextBack, DisplayName: Show Next and Back Buttons, FieldType: Boolean, DefaultValue: True
#DesignerProperty: Key: HeaderSize, DisplayName: Header Size in Percent, FieldType: Int, DefaultValue: 50,  MinRange: 25, MaxRange: 75, Description: Set the height percentage of the upper Header View 
#DesignerProperty: Key: IndicatorActiveColor, DisplayName: Indicator Active Color, FieldType: Color, DefaultValue: 0xFFFFFFFF, Description: The Color of the Indicators they are active
#DesignerProperty: Key: IndicatorInactiveColor, DisplayName: Indicator Inactive Color, FieldType: Color, DefaultValue: 0x98FFFFFF, Description: The Color of the Indicators they are inactive

#Event: PageChange(Index as int)
#Event: GetStartedButtonClick
#Event: BaseResize(Width As Double, Height As Double)
#Event: SkipButtonClicked(mode as string)

Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mBase As B4XView 'ignore
	Private xui As XUI 'ignore
	
	'Views
	Private xasvp_main As ASViewPager	
	Private xpnl_circlebackground As B4XView
	Private xlbl_skipbtn,xlbl_nextbtn,xlbl_backbtn,xlbl_getstartedbtn As B4XView		
	Private IndicatorsCVS As B4XCanvas
		
	'Properties
	Private g_NextButtonText,g_BackButtonText,g_SkipButtonText,g_FinishButtonText As String
	Private g_IndicatorActiveColor,g_IndicatorInactiveColor As Int
	Private g_HeaderSize As Float
	Private g_ShowSkipButton,g_ShowFinishButton,g_ShowNextBack As Boolean
	Private g_skipbuttonmode As String = "Skip"
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
End Sub

'Base type must be Object
Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mBase = Base
  	
	If xasvp_main.IsInitialized = False Then
		ini_props(Props)
		ini_views
	End If
	
	#If B4A
	Base_Resize(mBase.Width,mBase.Height)
	#End If
	
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
	
	xasvp_main.Base_Resize(Width,Height)
	
	xpnl_circlebackground.SetLayoutAnimated(0,0,Height - 30dip,Max(2dip, Width),20dip)
	
	IndicatorsCVS.Resize(xpnl_circlebackground.Width, xpnl_circlebackground.Height)
	DrawIndicators(xpnl_circlebackground.Height,xasvp_main.CurrentIndex)
	
	xlbl_backbtn.SetLayoutAnimated(0,0dip,Height - 40dip - 40dip,100dip,40dip)
	xlbl_nextbtn.SetLayoutAnimated(0,Width - 100dip,Height - 40dip - 40dip,100dip,40dip)
	xlbl_skipbtn.SetLayoutAnimated(0,Width/2 - (Width - xlbl_backbtn.Width - xlbl_nextbtn.Width)/2,Height - xpnl_circlebackground.Height - 40dip,Max(2dip,Width - xlbl_backbtn.Width - xlbl_nextbtn.Width),40dip)
	xlbl_getstartedbtn.SetLayoutAnimated(0,Width/2 - (Width - xlbl_backbtn.Width - xlbl_nextbtn.Width)/2,Height - 40dip - 40dip,Max(2dip,Width - xlbl_backbtn.Width - xlbl_nextbtn.Width),40dip)
	
	For i = 0 To xasvp_main.Size -1
		
		Dim xpnl_page As B4XView = xasvp_main.GetPanel(i)
		Dim xpnl_headerarea As B4XView = xpnl_page.GetView(0)
		Dim xpnl_bottomarea As B4XView = xpnl_page.GetView(1)
		
		Dim xlbl_header_text As B4XView = xpnl_bottomarea.GetView(0)
		Dim xlbl_description_text As B4XView = xpnl_bottomarea.GetView(1)
		
		xpnl_headerarea.SetLayoutAnimated(0,0,0,Max(2dip,Width),Max(2dip,getHeaderHeight))
		xpnl_bottomarea.SetLayoutAnimated(0,0,Height * g_HeaderSize,Max(2dip,Width),Max(2dip,Height * (1 - g_HeaderSize)))
		xlbl_header_text.SetLayoutAnimated(0,5dip,5dip,Max(2dip,Width - 10dip),50dip)
		xlbl_description_text.SetLayoutAnimated(0,5dip,xlbl_header_text.Height +5dip,Max(2dip,Width - 10dip),Max(2dip,(35 * xpnl_bottomarea.Height)/100))'xlbl_header_text.Top + xlbl_header_text.Height
	
	Next

	If xui.SubExists(mCallBack, mEventName & "_BaseResize",2) Then
		CallSub3(mCallBack, mEventName & "_BaseResize",Width,Height)
	End If

End Sub

Private Sub ini_props(Props As Map)
	
	g_NextButtonText = Props.Get("NextButton")
	g_BackButtonText = Props.Get("BackButton")
	g_SkipButtonText = Props.Get("SkipButton")
	g_FinishButtonText = Props.Get("FinishButtonText")
	g_ShowSkipButton = Props.Get("ShowSkipButton")
	g_ShowFinishButton = Props.Get("ShowFinishButtonText")
	g_HeaderSize = Props.Get("HeaderSize")  /100
	g_IndicatorActiveColor = xui.PaintOrColorToColor(Props.Get("IndicatorActiveColor"))
	g_IndicatorInactiveColor = xui.PaintOrColorToColor(Props.Get("IndicatorInactiveColor"))
	g_ShowNextBack = Props.Get("ShowNextBack")
	
End Sub

Private Sub ini_views
	
	xasvp_main.Initialize(Me,"xasvp_main")
	xasvp_main.DesignerCreateView(mBase,CreateLabel("",False),CreateMap("Orientation":"Horizontal"))
	
	xpnl_circlebackground = xui.CreatePanel("")
	xlbl_backbtn = CreateLabel("xlbl_backbtn",False)
	xlbl_nextbtn = CreateLabel("xlbl_nextbtn",False)
	xlbl_skipbtn = CreateLabel("xlbl_skipbtn",False)
	xlbl_getstartedbtn = CreateLabel("xlbl_getstartedbtn",False)
	
	mBase.AddView(xpnl_circlebackground,0,0,2dip,2dip)
	mBase.AddView(xlbl_backbtn,0,0,2dip,2dip)
	mBase.AddView(xlbl_nextbtn,0,0,2dip,2dip)
	mBase.AddView(xlbl_skipbtn,0,0,2dip,2dip)
	mBase.AddView(xlbl_getstartedbtn,0,0,2dip,2dip)
	
	ViewDefaultValues(xlbl_backbtn,xui.CreateDefaultBoldFont(15),g_BackButtonText,False)
	ViewDefaultValues(xlbl_nextbtn,xui.CreateDefaultBoldFont(15),g_NextButtonText,g_ShowNextBack)
	ViewDefaultValues(xlbl_skipbtn,xui.CreateDefaultFont(15),g_SkipButtonText,g_ShowSkipButton)
	ViewDefaultValues(xlbl_getstartedbtn,xui.CreateDefaultBoldFont(15),g_FinishButtonText,False)
	
	IndicatorsCVS.Initialize(xpnl_circlebackground)
	
End Sub

Public Sub AddPage(HeadingText As String,Description As String,BackgroundColor As Int,HeaderLayout As B4XView,Tag As Object)
	
	Dim xpnl_page As B4XView = xui.CreatePanel("")
	xpnl_page.SetLayoutAnimated(0,0,0,Max(2dip,mBase.Width),Max(2dip,mBase.Height))
	xpnl_page.Color = BackgroundColor
	
	Dim xpnl_headerarea As B4XView = xui.CreatePanel("xpnl_headerarea")
	Dim xpnl_bottomarea As B4XView = xui.CreatePanel("xpnl_bottomarea")
	
	xpnl_headerarea = HeaderLayout
	
	xpnl_page.AddView(xpnl_headerarea,0,0,Max(2dip,mBase.Width),Max(2dip,getHeaderHeight))
	xpnl_page.AddView(xpnl_bottomarea,0,0,Max(2dip,mBase.Width),Max(2dip,mBase.Height * (1 - g_HeaderSize)))
	
	Dim xlbl_header_text As B4XView = CreateLabel("",False)
	Dim xlbl_description_text As B4XView = CreateLabel("",True)
	
	xlbl_header_text.Text = HeadingText
	xlbl_description_text.Text = Description
	
	xpnl_bottomarea.AddView(xlbl_header_text,0,0,Max(2dip,0),Max(2dip,0))
	xpnl_bottomarea.AddView(xlbl_description_text,0,0,Max(2dip,0),Max(2dip,0))
	
	xasvp_main.AddPage(xpnl_page,Tag)
	DrawIndicators(xpnl_circlebackground.Height,xasvp_main.CurrentIndex)
	
	xlbl_header_text.TextColor = xui.Color_White
	xlbl_header_text.SetTextAlignment("CENTER","CENTER")
	xlbl_header_text.Font = xui.CreateDefaultBoldFont(20)
	xlbl_description_text.TextColor = xui.Color_White
	xlbl_description_text.SetTextAlignment("TOP","CENTER")
	#IF B4J
	Dim jo As JavaObject = xlbl_description_text
	jo.RunMethod("setTextAlignment", Array("CENTER"))
	#End IF
	xlbl_description_text.Font = xui.CreateDefaultFont(15)
	
	xpnl_headerarea.SetLayoutAnimated(0,0,0,Max(2dip,mBase.Width),Max(2dip,getHeaderHeight))
	xpnl_bottomarea.SetLayoutAnimated(0,0,mBase.Height * g_HeaderSize,Max(2dip,mBase.Width),Max(2dip,mBase.Height * (1 - g_HeaderSize)))
	xlbl_header_text.SetLayoutAnimated(0,5dip,5dip,Max(2dip,mBase.Width - 10dip),50dip)
	xlbl_description_text.SetLayoutAnimated(0,5dip,xlbl_header_text.Height +5dip,Max(2dip,mBase.Width - 10dip),Max(2dip,(35 * xpnl_bottomarea.Height)/100))'xlbl_header_text.Top + xlbl_header_text.Height
	ShowOrHide(getCurrentIndex)
End Sub

Public Sub RemovePage(Index As Int)	
	xasvp_main.RemovePage(Index)	
	DrawIndicators(xpnl_circlebackground.Height,Index)
End Sub

Private Sub xasvp_main_PageChanged(Index As Int)	
	DrawIndicators(xpnl_circlebackground.Height,Index)
	PageChangeHandler(Index)
	ShowOrHide(Index)
End Sub

Private Sub ShowOrHide(index As Int)
	If index = 0 Then xlbl_backbtn.Visible = False Else xlbl_backbtn.Visible = g_ShowNextBack
	If index = xasvp_main.Size -1 Then xlbl_nextbtn.Visible = False Else xlbl_nextbtn.Visible = g_ShowNextBack
	If index = xasvp_main.Size -1 Then	xlbl_getstartedbtn.Visible = g_ShowFinishButton Else xlbl_getstartedbtn.Visible = False
	If index < xasvp_main.Size -1 Then	xlbl_skipbtn.Visible = g_ShowSkipButton Else xlbl_skipbtn.Visible = False
End Sub

Private Sub b4x_backbtnClick	
	If xasvp_main.Size > 0 And xasvp_main.CurrentIndex > 0 Then		
		If xasvp_main.CurrentIndex = 0 Then xlbl_backbtn.Visible = False
		xasvp_main.PreviousPage
	End If	
End Sub

#If B4J

Private Sub xlbl_backbtn_MouseClicked (EventData As MouseEvent)	
	b4x_backbtnClick	
End Sub

#Else

Private Sub xlbl_backbtn_Click	
	b4x_backbtnClick	
End Sub

#End If

Private Sub b4x_nextbtnClick	
	If xasvp_main.Size > 0 And xasvp_main.CurrentIndex < xasvp_main.Size -1 Then
		xlbl_backbtn.Visible = True
		xasvp_main.NextPage
	End If	
End Sub

#If B4J
Private Sub xlbl_nextbtn_MouseClicked (EventData As MouseEvent)
	b4x_nextbtnClick
End Sub
#Else
Private Sub xlbl_nextbtn_Click	
	b4x_nextbtnClick
End Sub
#End If

#If B4J
Private Sub xlbl_skipbtn_MouseClicked (EventData As MouseEvent)	
	SkipButtonClickHandler	
End Sub
#Else
Private Sub xlbl_skipbtn_Click	
	SkipButtonClickHandler
End Sub
#End If

Private Sub SkipButtonClickHandler
	If g_skipbuttonmode = SkipButtonMode_CLOSE Then
		If xui.SubExists(mCallBack, mEventName & "_SkipButtonClicked",1) Then
			CallSub2(mCallBack, mEventName & "_SkipButtonClicked",g_skipbuttonmode)
		End If		
		Else
		xasvp_main.CurrentIndex = xasvp_main.Size -1
		If xui.SubExists(mCallBack, mEventName & "_SkipButtonClicked",1) Then
			CallSub2(mCallBack, mEventName & "_SkipButtonClicked",g_skipbuttonmode)
		End If
	End If
End Sub

#If B4J
Private Sub xlbl_getstartedbtn_MouseClicked (EventData As MouseEvent)	
	GetStartedButtonClickHandler	
End Sub
#Else
Private Sub xlbl_getstartedbtn_Click	
	GetStartedButtonClickHandler	
End Sub
#End If

#Region Enums
Public Sub SkipButtonMode_SKIP As String
	Return "Skip"
End Sub
Public Sub SkipButtonMode_CLOSE As String
	Return "Close"
End Sub
#End Region

#Region Properties
Public Sub setSkipButtonMode(mode As String)
	If mode = SkipButtonMode_CLOSE Then
		g_skipbuttonmode = SkipButtonMode_CLOSE
		Else
		g_skipbuttonmode = SkipButtonMode_SKIP
	End If
End Sub
Public Sub getSkipButtonMode As String
	Return g_skipbuttonmode
End Sub
'gets the Bottom Area Panel
Public Sub getBottomArea(Index As Int) As B4XView
	Return xasvp_main.GetPanel(Index).GetView(1)
End Sub
'gets the Header Area Panel to change the Header Layout
Public Sub getHeaderArea(Index As Int) As B4XView
	Return xasvp_main.GetPanel(Index).GetView(0)
End Sub
'If you want to change the background color of a page or you want to add your own views on the full page instead just on the header
Public Sub getPageBackgroundPanel(Index As Int) As B4XView
	Return xasvp_main.GetPanel(Index)
End Sub
'This View is based on the ASViewPager
Public Sub getViewPager As ASViewPager
	Return xasvp_main
End Sub
#If B4A or B4I
'The View is based of the ASViewPager and this Pager is based on the xCustomListView
Public Sub getCustomListView As CustomListView
	Return xasvp_main.CustomListView
End Sub
#Else
'The View is based of the ASViewPager and this Pager is based on the xCustomListView
Public Sub getCustomListView As jPager
	Return xasvp_main.jPager
End Sub
#End If

'sets or gets the current index
Public Sub setCurrentIndex(index As Int)
	xasvp_main.CurrentIndex = index
End Sub

Public Sub getCurrentIndex As Int
	Return xasvp_main.CurrentIndex
End Sub
'gets or sets the inactive indicator color
Public Sub setIndicatorInactiveColor(clr As Int)
	g_IndicatorInactiveColor = clr
	DrawIndicators(xpnl_circlebackground.Height,xasvp_main.CurrentIndex)
End Sub
Public Sub getIndicatorInactiveColor As Int
	Return g_IndicatorInactiveColor
End Sub
'gets or sets the active indicator color
Public Sub setIndicatorActiveColor(clr As Int)
	 g_IndicatorActiveColor = clr
	DrawIndicators(xpnl_circlebackground.Height,xasvp_main.CurrentIndex)
End Sub

Public Sub getIndicatorActiveColor As Int
	Return g_IndicatorActiveColor
End Sub


Public Sub setShowNextBack(visible As Boolean)
	g_ShowNextBack = visible
End Sub

Public Sub getShowNextBack As Boolean
	Return g_ShowNextBack
End Sub

Public Sub setShowFinishButton(visible As Boolean)
	g_ShowFinishButton = visible
End Sub

Public Sub getShowFinishButton As Boolean
	Return g_ShowFinishButton
End Sub

Public Sub setShowSkipButton(visible As Boolean)
	g_ShowSkipButton = visible
End Sub

Public Sub getShowSkipButton As Boolean
	Return g_ShowSkipButton
End Sub

Public Sub setShowIndicator(visible As Boolean)
	xpnl_circlebackground.Visible = visible
End Sub

Public Sub getFinishButtonText As B4XView
	Return xlbl_getstartedbtn
End Sub

Public Sub getSkipButtonText As B4XView
	Return xlbl_skipbtn
End Sub

Public Sub getBackButtonText As B4XView
	Return xlbl_backbtn
End Sub

Public Sub getNextButton As B4XView
	Return xlbl_nextbtn
End Sub

Public Sub setFinishButtonText(text As String)
	g_FinishButtonText = text
	xlbl_getstartedbtn.Text = text
End Sub

Public Sub setSkipButtonText(text As String)
	g_SkipButtonText = text
	xlbl_skipbtn.Text = text
End Sub

Public Sub setBackButtonText(text As String)
	g_BackButtonText = text
	xlbl_backbtn.Text = text
End Sub

Public Sub setNextButtonText(text As String)
	g_NextButtonText = text
	xlbl_nextbtn.Text = text
End Sub

'The header size must be between 25 and 75 if not the value is set to 50
Public Sub setHeaderSize(header_size As Float)
	If header_size >= 25 Or header_size <= 75 Then g_HeaderSize = header_size/100 Else g_HeaderSize = 50/100
	Base_Resize(mBase.Width,mBase.Height)
End Sub

'gets the Header Height
Public Sub getHeaderHeight As Float
	Return mBase.Height * g_HeaderSize
End Sub

#End Region

#Region Events

Private Sub PageChangeHandler(Page As Int)	
	If xui.SubExists(mCallBack, mEventName & "_PageChange",0) Then
		CallSub2(mCallBack, mEventName & "_PageChange",Page)
	End If
End Sub

Private Sub GetStartedButtonClickHandler	
	If xui.SubExists(mCallBack, mEventName & "_GetStartedButtonClick",0) Then
		CallSub(mCallBack, mEventName & "_GetStartedButtonClick")
	End If	
End Sub

#End Region

#Region Functions

'https://www.b4x.com/android/forum/threads/b4x-xui-imageslider.87128/
Private Sub DrawIndicators(Height As Float,Index As Int)
	'If pagelist.Size < Then Return
	IndicatorsCVS.ClearRect(IndicatorsCVS.TargetRect)
	Dim clr As Int
	For i = 0 To xasvp_main.Size - 1
		If Index = i Then clr = g_IndicatorActiveColor Else clr =  g_IndicatorInactiveColor
		IndicatorsCVS.DrawCircle(IndicatorsCVS.TargetRect.CenterX + (-(xasvp_main.Size - 1) / 2 + i) * 12dip, Height/2, 4dip, clr, True, 0)
		'Sleep(0)
	Next
	IndicatorsCVS.Invalidate
End Sub

Private Sub CreateLabel(EventName As String,Multiline As Boolean) As B4XView	'Ignore
	Dim tmp_lbl As Label
	tmp_lbl.Initialize(EventName)
	#IF B4J
	tmp_lbl.WrapText = Multiline
	#Else If B4I
	tmp_lbl.Multiline = Multiline
	#End IF
	Return tmp_lbl
End Sub

'Just to safe codelines :P
Private Sub ViewDefaultValues(View As B4XView,xFont As B4XFont,Text As String,Visible As Boolean)	
	View.TextColor = xui.Color_White
	View.SetTextAlignment("CENTER","CENTER")
	View.Font = xFont
	View.Text = Text
	View.Visible = Visible
End Sub

#End Region